#include <iostream>
#include <cstdio>
#include <set>
#include <utility>
#include <algorithm>
#include <vector>
#include <cstring>
#include <ctime>
using namespace std;
#define pb(a) push_back(a)
#define sz(a) ((int)(a).size())
#define INF 10000000
typedef pair<int,int> pii;
int N,M,F;
struct ship{
  int id , b , sp , cst , cap;
  bool operator<(const ship& w)const{
   return cst!=w.cst ? cst<w.cst : sp>w.sp;
                                    }
};
vector<ship> use;
vector<int> act[60];
int beg[1010] , end[1010] , dist[1010] , cnt[1010];
vector<int> fr[1010] , to[1010] , mnt[1010] , prof[1010] , how[1010];
// Reading input
void read(){
  scanf("%d%d%d",&N,&M,&F);
  use.resize(M);
  for(int i=0;i<M;++i)
   use[i].id = i ,
   scanf("%d%d%d%d",&use[i].b , &use[i].sp , &use[i].cst , &use[i].cap),
   --use[i].b;
  sort(use.begin() , use.end());
  for(int i=0;i<F;++i){
   scanf("%d%d%d%d",&beg[i] , &end[i] , &dist[i] , &cnt[i]);
   --beg[i]; --end[i];
   act[ beg[i] ].pb(i);
   fr[i].resize( cnt[i] ); to[i].resize( cnt[i] );
   mnt[i].resize( cnt[i] ); prof[i].resize( cnt[i] ); how[i].resize( cnt[i] );
   for(int j=0;j<cnt[i];++j)
    scanf("%d%d%d%d%d" , &fr[i][j] , &to[i][j] , &mnt[i][j] , &prof[i][j] , &how[i][j]);
                      }
}
// Getting cycle
int get_time(int len,int speed){
  int tim=len/speed;
  if(tim*speed < len)++tim;
  return tim;
}
set<pii> ban[60];
struct data{
  int vr , tim , tip , fl , WIN;
  data(int _vr=0,int _tim=0,int _tip=0,int _fl=0,int _WIN=0){
   vr=_vr; tim=_tim; tip=_tip; fl=_fl;
   WIN=_WIN;
                                                            }
};
int SHP;
int big[60][70][2]; // 64 max on 4 days
data next[60][70][2];
bool solv[60][70][2];
void init_solv(){
  memset(solv , 0 , sizeof solv);
}
void dfs(int vr,int tim,int tip){ // make to use ban
  if(solv[vr][tim][tip])return;
  solv[vr][tim][tip]=true;
  big[vr][tim][tip] = -INF;
  if(vr == use[SHP].b && tip==1){
   big[vr][tim][tip]=0;
   next[vr][tim][tip] = data(-1 , -1 , -1 , -1);
                                }
  if(tim+1<64){
   dfs(vr , tim+1 , tip);
   if(big[vr][tim+1][tip] > big[vr][tim][tip]){
    big[vr][tim][tip] = big[vr][tim+1][tip];
    next[vr][tim][tip] = data(vr , tim+1 , tip , -1);
                                              }
  int prt=tim%16;
  if(prt>=4){
   for(int i=0;i<sz(act[vr]);++i){
    int ID=act[vr][i];
    if( ban[vr].count(pii(end[ID] , prt/*tim*/)) )continue; // If banned - continue
    int etim = tim + get_time(dist[ID] , use[SHP].sp);
    if(etim/16 == tim/16){
     int win = -dist[ID] * use[SHP].cst * 4;
     for(int j=0;j<cnt[ID];++j){
      if(fr[ID][j] == prt && etim%16<=to[ID][j])
       win += prof[ID][j] * min(how[ID][j] , use[SHP].cap);
                               }
     dfs(end[ID] , etim , 1);
     if(win + big[ end[ID] ][etim][1] > big[vr][tim][tip]){
      big[vr][tim][tip] = win + big[ end[ID] ][etim][1];
      next[vr][tim][tip] = data(end[ID] , etim , 1 , ID , win);
                                                          }
                         }
                                 }
            }
              }
}
struct flight{
  int day,hour,tar;
  flight(int _day=0,int _hour=0,int _tar=0){
   day = _day; hour = _hour; tar=_tar;
                                           }
};
vector< flight > fl;
vector< flight > ANS[60];
void get_fl(){
  fl.clear();
  data cur(use[SHP].b , 0 , 0 , -1);
  while(cur.vr != -1){
   data nxt = next[ cur.vr ][ cur.tim ][ cur.tip ];
   if(nxt.fl>=0)ban[cur.vr].insert( pii(nxt.vr , cur.tim%16/*cur.tim*/) );
   if(nxt.fl >= 0){
    fl.pb( flight(cur.tim/16 +1 , cur.tim%16 , nxt.vr +1) );
                  }
   cur=nxt;
                     }
}
void put_stuff(int ship){
  // TODO
}
namespace SLOW{


// Getting cycle
int get_time(int len,int speed){
  int tim=len/speed;
  if(tim*speed < len)++tim;
  return tim;
}
set<pii> ban[60];
struct data{
  int vr , tim , tip , fl , WIN;
  data(int _vr=0,int _tim=0,int _tip=0,int _fl=0,int _WIN=0){
   vr=_vr; tim=_tim; tip=_tip; fl=_fl;
   WIN=_WIN;
                                                            }
};
int SHP;
int big[60][70][2]; // 64 max on 4 days
data next[60][70][2];
bool solv[60][70][2];
void init_solv(){
  memset(solv , 0 , sizeof solv);
}
void dfs(int vr,int tim,int tip){ // make to use ban
  if(solv[vr][tim][tip])return;
  solv[vr][tim][tip]=true;
  big[vr][tim][tip] = -INF;
  if(vr == use[SHP].b && tip==1){
   big[vr][tim][tip]=0;
   next[vr][tim][tip] = data(-1 , -1 , -1 , -1);
                                }
  if(tim+1<64){
   dfs(vr , tim+1 , tip);
   if(big[vr][tim+1][tip] > big[vr][tim][tip]){
    big[vr][tim][tip] = big[vr][tim+1][tip];
    next[vr][tim][tip] = data(vr , tim+1 , tip , -1);
                                              }
  int prt=tim%16;
  if(prt>=4){
   for(int i=0;i<sz(act[vr]);++i){
    int ID=act[vr][i];
    if( ban[vr].count(pii(end[ID] , tim)) )continue; // If banned - continue
    int etim = tim + get_time(dist[ID] , use[SHP].sp);
    if(etim/16 == tim/16){
     int win = -dist[ID] * use[SHP].cst * 4;
     for(int j=0;j<cnt[ID];++j){
      if(fr[ID][j] == prt && etim%16<=to[ID][j])
       win += prof[ID][j] * min(how[ID][j] , use[SHP].cap);
                               }
     dfs(end[ID] , etim , 1);
     if(win + big[ end[ID] ][etim][1] > big[vr][tim][tip]){
      big[vr][tim][tip] = win + big[ end[ID] ][etim][1];
      next[vr][tim][tip] = data(end[ID] , etim , 1 , ID , win);
                                                          }
                         }
                                 }
            }
              }
}
struct flight{
  int day,hour,tar;
  flight(int _day=0,int _hour=0,int _tar=0){
   day = _day; hour = _hour; tar=_tar;
                                           }
};
vector< flight > fl;
vector< flight > ANS[60];
const int rem = 60*16;
bool FLY[60][60][rem];
bool get_fl(){
  fl.clear();
  // putting ans
  data cur(use[SHP].b , 0 , 0 , -1);
  int cyc_len = 2;
  while(cur.vr != -1){
   data nxt = next[ cur.vr ][ cur.tim ][ cur.tip ];
   if(nxt.fl>=0)ban[cur.vr].insert( pii(nxt.vr , cur.tim) );
   if(nxt.fl >= 0){
    fl.pb( flight(cur.tim/16 +1 , cur.tim%16 , nxt.vr +1) );
                  }
   cyc_len = max(cyc_len , cur.tim/16 +2);
   cur=nxt;
                     }
  // putting BAN
  cur = data(use[SHP].b , 0 , 0 , -1);
  while(cur.vr != -1){
   data nxt = next[ cur.vr ][ cur.tim ][ cur.tip ];
   if(nxt.fl>=0){
    int ctim=cur.tim;
    while(ctim<rem){
     if(FLY[cur.vr][nxt.vr][ctim])return false;
     FLY[cur.vr][nxt.vr][ctim] = true;
     ctim += cyc_len * 16;
                   }          
                }
   cur=nxt;
                     }
  return true;
}

};
int main(){
  double _beg=clock();
  freopen("flights.in" , "r" , stdin);
  freopen("flights.out" , "w" , stdout);
  read();
  for(SHP=0;SHP<sz(use);++SHP){
   init_solv();
   dfs(use[SHP].b , 0 , 0);
   get_fl();
   ANS[ use[SHP].id ] = fl;
                              }
  if( (clock()-_beg)/CLOCKS_PER_SEC > 0.5){
   for(int i=0;i<M;++i){
    printf("%d\n" , sz(ANS[i]));
    for(int j=0;j<sz(ANS[i]);++j)
     printf("%d %d %d\n" , ANS[i][j].day , ANS[i][j].hour , ANS[i][j].tar);
                       }
                                          }
  else{
  bool OK=true;
  for(SLOW::SHP=0;SLOW::SHP<sz(use);++SLOW::SHP){
   SLOW::init_solv();
   SLOW::dfs(use[SLOW::SHP].b , 0 , 0);
   OK = OK && SLOW::get_fl();
   if(!OK)break;
   SLOW::ANS[ use[SLOW::SHP].id ] = SLOW::fl;
                                                }
  if(OK){
  
   for(int i=0;i<M;++i){
    printf("%d\n" , sz(SLOW::ANS[i]));
    for(int j=0;j<sz(SLOW::ANS[i]);++j)
     printf("%d %d %d\n" , SLOW::ANS[i][j].day , SLOW::ANS[i][j].hour , SLOW::ANS[i][j].tar);
                       }
  
        }
  else{
   
   for(int i=0;i<M;++i){
    printf("%d\n" , sz(ANS[i]));
    for(int j=0;j<sz(ANS[i]);++j)
     printf("%d %d %d\n" , ANS[i][j].day , ANS[i][j].hour , ANS[i][j].tar);
                       }
      }         
                 
      }
  //system("pause");
  return 0;
}
